/*

	Copyright _ 2005, David Foucher.

	This file is part of NoteIt!.

    NoteIt! is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    NoteIt! is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var _widget = {
	front : document.getElementById("front"),
	back : document.getElementById("back"),
	tmpfileURL: '/tmp/noteit.tmp',
	device: null,
	version: null,
	text : {nbchars : 0},
	notelimit : 256,//limit in nb caracters//
	alertTextLoad : null,
	download_link : 'http://liferack.free.fr/noteit.html'
	};


var _device = {
	type : null,
	company_list : null,
	nb_phones : null,
//	nbPhones : getNbDevice("Phones"), //tmp
	default_list : new Array("Sony-Ericsson","Nokia","Other"),
	makeList : function() {getTypeOfDevice();}//getTypeOfDevice

};

var ipod = {
	name : null,
	notelimit : 3750, //limit in chars//
	check : function () {checkiPod();}
	};


//-------------------------------------------------------//
//Widgets events
//-------------------------------------------------------//
function onKeyDown (event) {

	if (event.altKey && event.charCode == 230)
	{showAlert(); event = null;}

	//showAlert(event.charCode);

	switch (event.charCode) {
		case 8:				//del key
		loadTextMeasure(event);
		document.getElementById("inputText").focus();
		break;
		}
//metakeys
	if (event.metaKey){
	switch (event.charCode){
		case 118:
		doTextTasks(event);
		setTimeout('document.getElementById("inputText").blur();',10);
		setTimeout('document.getElementById("inputText").focus();',100);
		break;
		case 120:
		doTextTasks(event);
		break;
		}
	}

}

function onKeyUp (event) {
	element = event.target;
	switch (element.nodeName) {
		case "TEXTAREA":
		doTextTasks(event);
		break;
		}
	}

function onClick (event) {
	element = event.target;

	switch (element.id) {
		case "inputText":
		doTextTasks(event);
		break;
		case "flip" :
		checkiPod(event);
		showBack(event);
		break;
		case "ButtonSend" :
		case "ButtonNew" :
		loadTextMeasure(event);
		break;
		default:
		hideAlert();
		}
	switch (element.name) {
		case "fileType":
		setTypeOfDevice(_device.default_list[element.value]);
		loadTextMeasure(event);
		break;
		}
}

function onBlur (event) {
		element = event.target;

	switch (element.id) {
		case "inputText":
		makeTmpfile(event);
		break;
		}
}

//close widget event
function onRemove() {
    if (window.widget) {
        widget.setPreferenceForKey(null, createKey("device"));
        delTmpFiles();
    }
}

//-------------------------------------------------------//
//Widget setup
//-------------------------------------------------------//

function loaded(){

//eventhandler
	document.addEventListener("keydown", onKeyDown, false);
	document.addEventListener("keyup", onKeyUp, false);
	document.addEventListener("click", onClick, false);
	document.getElementById("inputText").addEventListener("DOMFocusOut",onBlur, false);

//buttons
	var doneButton = document.getElementById("doneButton");
    createGenericButton(doneButton, getLocalizedString("Done"), hideBack);

	var checkButton = document.getElementById("checkButton");
    createGenericButton(checkButton, getLocalizedString("Check for update"), function () {performRequest("http://liferack.free.fr/Info.plist", checkVersion)});

	performRequest ("Info.plist", outputVersion);

	_device.makeList();

	if (window.widget)widget.onremove = onRemove;

	}

//-------------------------------------------------------//
//Widget gui elements
//-------------------------------------------------------//

// Animate progrees bar
function loadTextMeasure(e)
{

	var maxChars = getMaxChars();
	var nbChars = _widget.text.nbchars;
	var maxS = 62;
	var initxSB = 35;
	var initxS = 34;
 var xSB = Math.round((nbChars*maxS)/maxChars)+34;
 var lSB = 63 - Math.round((nbChars*maxS)/maxChars);

 if ((nbChars > maxChars && e.charCode != 0 && e.charCode != 8) || e.target.id == "flip"){
  	document.getElementById("inputText").value.substring(maxChars,nbChars);
 	document.getElementById("inputText").blur();}

 if (_widget.alertTextLoad)clearInterval(_widget.alertTextLoad);
 if (lSB > -1){
 document.getElementById("StatusBar").style.left=xSB;
 if (xSB > 77 && xSB< 90){document.getElementById("Status").style.backgroundImage="url('Images/txt_measure_yellow.png')";}
 else if (xSB >= 90){document.getElementById("Status").style.backgroundImage="url('Images/txt_measure_red.png')";}
 else if (xSB <= 77){document.getElementById("Status").style.backgroundImage="url('Images/txt_measure_green.png')";}
 document.getElementById("Status").style.left=(xSB);
 document.getElementById("Status").style.width=lSB;

 // if more character than expected
 }else{

 lSB = 63; xSB = 34;
 document.getElementById("StatusBar").style.left=xSB;
 //document.getElementById("Status").style.backgroundImage="url('Images/txt_measure_red.png')";
 if (_widget.alertTextLoad)clearInterval(_widget.alertTextLoad);
 _widget.alertTextLoad = setInterval ("loadTextAlert()",500);
  document.getElementById("Status").style.left=(xSB);
 document.getElementById("Status").style.width=lSB;
 }
}

function loadTextAlert () {
	if (document.getElementById("Status").style.backgroundImage != "none")
	document.getElementById("Status").style.backgroundImage = "none";
	else
	 document.getElementById("Status").style.backgroundImage="url('Images/txt_measure_red.png')";
	 }
// Show or Hide Preferences Pane

function showBack()
{

    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToBack");
    front.style.display="none";
    back.style.display="block";
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);

}

function hideBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
        widget.prepareForTransition("ToFront");
    back.style.display="none";
    front.style.display="block";
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);

}

//buttons

function buttonNew()
{
	document.getElementById("ButtonNew").src = "Images/newdown.png";
	document.getElementById("inputBackgroundImage").style.visibility = "visible";
	document.getElementById("inputText").style.visibility = "visible";
	document.getElementById("inputText").value = "";
	setNbChars(0);
	hideAlert();
}

function buttonSend()
{
	document.getElementById("ButtonSend").src = "Images/senddown.png";
	document.getElementById("Bluetooth_on").style.visibility = "visible";
	document.getElementsByTagName("textarea")[0].style.visibility = "hidden";
	document.getElementById("inputBackgroundImage").style.visibility = "hidden";
    document.getElementById("inputText").blur();
	sendToBTdevice();
	document.getElementById("Bluetooth_on").style.visibility = "hidden";
	setNbChars(0);
	delTmpFiles("/tmp/noteit.tmp");

	}

function buttonNewUpOut()
{
	document.getElementById("ButtonNew").src = "Images/newup.png";
	document.getElementById("inputText").focus();
}

function buttonSendUpOut()
{
	document.getElementById("ButtonSend").src = "Images/sendup.png";
}

//TODO add localization for "Other" item
// list of phone types
function outputPrefFileType(e) {

//init file type list
	var list = document.getElementById("fileType");
	selectelement = document.createElement("select");
	cname = document.createAttribute("name");
	cname.nodeValue="fileType";
	var mytext = _device.default_list;

	list.appendChild(selectelement);
	attribut = document.createAttribute("size");
	attribut.nodeValue=1;
	list.firstChild.setAttributeNode (attribut);
	list.firstChild.setAttributeNode (cname);
	var myoption = new Array;
	var myvalue = new Array;
	var textnode = new Array;
	for (i=0; i<mytext.length; i++)
	{
	myoption[i] = document.createElement("option");
	myvalue[i] = document.createAttribute("value");
	textnode[i] = document.createTextNode(mytext[i]);
	myvalue[i].nodeValue = i;

	//textnode[i].nodeValue = ;
	list.firstChild.appendChild(myoption[i]);
	list.firstChild.childNodes[i].setAttributeNode(myvalue[i]);
	list.firstChild.childNodes[i].appendChild(textnode[i]);

	if (getPreference("device") == list.firstChild.childNodes[i].firstChild.data)
	list.firstChild.childNodes[i].selected = true;
	}
}

// alert message
function showAlert(text, option){
	if (text != null){
	(!option?option=true:option=false)
	var mess = document.getElementById("alert");
	node = document.createTextNode(text);
	if (option)
	{
	switch (typeof (option)){
	case "boolean":
	mess.replaceChild(node, mess.firstChild);
	break;
	case "number":
	mess.replaceChild(node, mess.firstChild);
	var time = option*1000;
	setTimeout('hideAlert()',time); //TODO pb d'accumulation de la fonction - devrait Ãªtre actif uniquement pour le dernier appel de la fonction
	}
	}else
	mess.appendChild(node);
	mess.previousSibling.previousSibling.style.visibility = "visible";
	mess.style.visibility = "visible";
	}else{
	mess.previousSibling.previousSibling.style.visibility = "visible";
	mess.style.visibility = "visible";
	}
}

// alert message
function hideAlert(){
	var mess = document.getElementById("alert");
	mess.previousSibling.previousSibling.style.visibility = "none";
	mess.style.visibility = "none";
	}

//-------------------------------------------------------//
//Preferences settup
//-------------------------------------------------------//


// get the company-name of bluetooth devices
function getCompanyName (url){

  xmlhttp = new XMLHttpRequest();
  xmlhttp.open("GET", url, false);
 xmlhttp.onreadystatechange=function() {
  if (xmlhttp.readyState==4) {
	xmldoc = xmlhttp.responseText;
 }

}
xmlhttp.send(null);
regex = /com.apple.company-name<\/key>\s\t<string>(.*)<\//;
text = xmldoc.match(regex);
return text[1];
}

//number of device
function getNbDevice (type) {
	if (widget.system){
	var nbDevice = widget.system("ls -1A ~/Library/"+type+"/ | grep -cv \"\\(^\\.\\)\"", null).outputString;
		return nbDevice;
	}

	}

//retrieve  preferences files
function copyPhonePlistToTmp () {
	var sys1=null; var sys2=null; var sys3=null;

	if (widget.system("/bin/ls .noteit.tmp",null).status == 0)
	if (widget.system("/bin/ls .noteit.tmp | grep -c xml",null).outputString != 0)
	return "0";

	sys1 = widget.system("/bin/mkdir .noteit.tmp",null).status;
	sys2 = widget.system("/usr/bin/find ~/Library/Phones -name Info.plist | /usr/bin/grep -n \".*\" | /usr/bin/awk \'{dst=$0;gsub(\":.*phone/\",\"_\",dst); split($0,a,\":\"); res=\".noteit.tmp/\" dst; gsub(\"\ \",\"\\\\ \",a[2]); gsub(\"\'\"\'\"\'\",\"\\x5C\\x27\",a[2]); print(\"cp\",a[2],res);}\' | sh",null).outputString;
	sys3 = widget.system("/usr/bin/plutil -convert xml1 -e xml .noteit.tmp/*.plist",null).status;
	sys4 = widget.system("rm -f .noteit.tmp/*.plist",null).status;
	//sys5 = widget.system("echo \""+sys2+"\" > /tmp/noteit.log",null).status;
	return "sys1:"+sys1+"\n sys2:"+sys2+"\n sys3:"+sys3;
}

// get the list of phone's brand
function getListCompanyNameOfPhone () {
	var companyname = new Array;
	_device.nb_phones = getNbDevice("Phones"); //TODO rÃ©crire la variable
	if (_device.nb_phones != 0){
	for (var i=0; i<getNbDevice("Phones"); i++)
	{
	var myurl = ".noteit.tmp/"+(i+1)+"_Info.xml";
		companyname[i] = getCompanyName(myurl);
		companyname.delDbl(i); // delete all same values if exist
		}
		_device.company_list = companyname;   //TODO rÃ©crire la variable company (setter/globale??)
		return companyname;
		} else {return companyname;}
}

// Reset device var if a brand x exists in the list
function testCompanyNameOfPhone(company) {
if (_device.nb_phones == null) getListCompanyNameOfPhone();
if (_device.nb_phones == 0)
	{
		setTypeOfDevice("Other");
		return "";
		}
		for (i=0; i<_device.nb_phones; i++)
			{
				if (_device.company_list[i] == company)
				{
				setTypeOfDevice(company);
				break;
				}
				else
				{
				setTypeOfDevice("Other");
				}
			}
}


// choose what file type to choose
function getTypeOfDevice(e) {

	if(!widget.preferenceForKey(createKey("device"))){
	copyPhonePlistToTmp ();

	var listOfDevice = getListCompanyNameOfPhone ();

    if (checkiPod()){
	 listOfDevice.unshift("iPod");}

	if (listOfDevice.length == 0)
	{
		_widget.device = "Other";
		widget.setPreferenceForKey( _widget.device, createKey("device"));
		outputPrefFileType(e);
		return "";
		}

		for (i=0; i<listOfDevice.length; i++)
			{
				for (j=0; j<_device.nb_phones; j++)
				{
					if (_device.default_list[j] == listOfDevice[i])
					{
					_widget.device = _device.default_list[j];
					widget.setPreferenceForKey( _widget.device, createKey("device"));
					outputPrefFileType(e);
					return null;
					}

				}
			}
			if (getNbDevice("Phones") != 0) // no-one devices found are in the default-list
			{setTypeOfDevice("Other");}else{setTypeOfDevice("iPod");}
			outputPrefFileType(e);
			}else{
		ipod.check();
		outputPrefFileType(e);
		_widget.device = widget.preferenceForKey(createKey("device"));
		}
}

//set preferences device
function setTypeOfDevice(type) {

	_widget.device = type;
	widget.setPreferenceForKey(type, createKey("device"));

}

// get version
function getVersion(request) {
    var version = "?";
    try {

        var response = request.responseXML;
        var key, i = 0;
        while ((key = response.getElementsByTagName("key")[i++])) {
            if (key.firstChild.data == "CFBundleVersion") break;
        }
        if (key) {
            var string = key.nextSibling;
            while (string && string.nodeType != 1) {
                string = string.nextSibling;
            }
            version = string ? string.firstChild.data : "?";
        }
    } catch (ex) {}
    return version;
}

function setWidgetVersion(request) {
	_widget.version =  getVersion(request);
	}

// print version
function outputVersion(request) {
    var version = document.getElementById("version");
 	if (typeof request != "undefined")
	setWidgetVersion(request);
    version.innerText = "Version " + _widget.version;
    version.style.color = "white";
}

// check version
function checkVersion(request) {
	var update = "up to date";
	remoteversion = getVersion(request);

	if (_widget.version != remoteversion && remoteversion != "?")
	{document.getElementById("version").innerText = getLocalizedString("new version "+remoteversion+" available");
	document.getElementById("version").style.color = "yellow";
	changeGenericButton (checkButton, getLocalizedString("Download"), function () {widget.openURL(_widget.download_link)});
	}
	else if (_widget.version == remoteversion)
	{document.getElementById("version").innerText = getLocalizedString("you've got last version");
	document.getElementById("version").style.color = "yellow";
	setTimeout ('outputVersion()',2000);
	}else{
	document.getElementById("version").innerText = getLocalizedString("internet connection failed");
	document.getElementById("version").style.color = "yellow";
	setTimeout ('outputVersion()',2000);
	}
}

// check ipod and set name
function checkiPod(e) {

	//var sys = widget.system("/usr/bin/find /Volumes -name iPod_Control | awk \'{res=$0 ; split ($0,a,\"/\"); print (a[3]);}\'",null).outputString; 
	//if (sys == "null")sys=0;
		//var name = widget.system("/usr/bin/more /tmp/ipod.test",null).outputString;
	
	var name = widget.system("/usr/bin/ruby -s NoteIt.rb -ipodname",null).outputString;
	if(name != "false")
	{ipod.name = name;
	iPodAdd(e);
	return true;}
	else
	{ipod.name = null;
	iPodRemove(e);
	return false;}
}

// add ipod to device default list
function iPodAdd (e) {
	if(ipod.name != null){
	if(_device.default_list[0] != "iPod"){
	_device.default_list.unshift("iPod");
	if(e)
	{addOptionElement("fileType","iPod",0);
	}
	else
	{return null;}
		}
	}
}

// remove ipod to device default list
function iPodRemove (e) {
	if(ipod.name == null){
	if(_device.default_list[0] == "iPod"){
	_device.default_list.shift();
	if(e)
	{removeOptionElement("fileType",0);
    setTypeOfDevice(_device.default_list[0]);
	}
	else
	{return null;}
		}
	}
}

function getMaxChars() {
	if (_widget.device != "iPod")
	{return _widget.notelimit;}
	else
	{
//	tmpfilesize = getFilesize(_widget.tmpfileURL);
//	var nbchars = document.getElementById("inputText").value.length+1;
//:	if (tmpfilesize > nbchars){
//	var notelimit = Math.round((nbchars/tmpfilesize)*ipod.notelimit);}
//	if (isNaN(notelimit))
	var notelimit = ipod.notelimit;
//	showAlert(nbchars+" "+tmpfilesize+" "+ipod.notelimit+" "+notelimit, true);
	return notelimit;
	}
}

//-------------------------------------------------------//
//Widget actions
//-------------------------------------------------------//

function makeTmpfile(e) {
				var text = document.getElementById("inputText");
				setNbChars();
		if (getMaxChars()<_widget.text.nbchars){
			var resizetext = text.value.substring(0,getMaxChars());
			text.value = resizetext;}
			text2file = text.value.replace(/\'/g,"=27");

			if (e.type == "DOMFocusOut" || e.charCode == 118 || e.charCode == 8){
			var commandtmp = widget.system("echo \'"+text2file+"\' > "+_widget.tmpfileURL, null).status;
			setNbChars();
			loadTextMeasure(e);
			//if (e.type == "DOMFocusOut")stopPropagation();
			}
}

function sendToBTdevice () {
//showAlert("device :"+_widget.device);
	//commandmkfile = widget.system("iconv -c -f UTF-8 -t UTF-7 /tmp/noteit1.tmp > /tmp/noteit.tmp", null).outputString;
	switch (_widget.device){
	case "Sony-Ericsson":
	commandRuby = widget.system("/usr/bin/ruby -s NoteIt.rb -sony", null).outputString;
	break;
	case "Nokia":
	commandRuby = widget.system("/usr/bin/ruby -s NoteIt.rb -nokia", null).outputString;
	break;
	case "iPod":
	commandRuby = widget.system("/usr/bin/ruby -s NoteIt.rb -ipod", null).outputString;
	break;
	case "Other":
	case null:
	command2 = widget.system("/usr/bin/ruby NoteIt.rb", null).outputString;
	break;
	}

	}

//-------------------------------------------------------//
//Other functions
//-------------------------------------------------------//

//add or remove element
function addOptionElement(id, text, index) {
	var selectelement = document.getElementById(id).firstChild;
	var optionelement = document.getElementById(id).firstChild.childNodes;
	var myoption = document.createElement("option");
	var myvalue = document.createAttribute("value");
	var mytext = document.createTextNode(text);
	myvalue.nodeValue = index;

	myoption.appendChild(mytext);
	myoption.setAttributeNode(myvalue);
	selectelement.insertBefore(myoption,optionelement[index]);
	recreateIndexOfElement(selectelement, index);
	
	}

function removeOptionElement(id, n){
	var selectelement = document.getElementById(id).firstChild;
	var todeltext = document.getElementById(id).firstChild.childNodes[n];
	document.getElementById(id).firstChild.removeChild(todeltext);
	recreateIndexOfElement(selectelement, 0);
	}
	
function recreateIndexOfElement(element, index) {

var myvalue = new Array;
    for (var i=index; i<element.childNodes.length; i++)
    {
    myvalue[i] = document.createAttribute("value");
    myvalue[i].nodeValue = i;
    element.childNodes[i].setAttributeNode(myvalue[i])
    }
    }
    
    

//file size
function getFilesize(url) {
	size = widget.system("/bin/ls -l "+url+" | awk '{print $5}'",null).outputString;
	return size;

	}

// delete all same values of an array if exist
Array.prototype.delDbl = function (key) {


	for (i=0; i<this.length; i++)
	{
		if (this[i] == this[key] && this[i] !=null && i != key)
		{
			var length = this.length;
 			 if (key >= length || key<0)
    				return;

  				for (j=key; j<length-1; j++)
    				this[j] = this[j+1];
  				this.length--;
		}

	}
}

//perform a request
function performRequest(url, callback) {
    var request = new XMLHttpRequest();
    request.overrideMimeType("text/xml");
    request.setRequestHeader("Cache-Control", "no-cache");
    //request.setRequestHeader("Accept-Language", getLocalizedString("Language") );
    request.open("GET", url);
    request.onload = function() { callback(request) };
    request.send(null);
    return request;
}

// change a button
function changeGenericButton (div, title, onaction)
{


	//rename title button
	buttonText = div.firstChild.nextSibling;

	f = buttonText.firstChild.nodeValue.length;
	buttonText.firstChild.replaceData(0,f,title);


	div.setAttribute ("genericButtonOnAction", onaction);
	div.setAttribute ("onmousedown", "genericButtonMouseDownHandler(event, this);");
	div.genericButtonEnabled = true;
	div.genericButtonInside = true;
	div.genericButtonAction = onaction;
}

//localization
function getLocalizedString (key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}

//create key name
function createKey(key) {
    if (window.widget) {
        return widget.identifier + "-" + key;
    }
    return key;
}

function getPreference(key) {
	if (window.widget) {
		if (widget.preferenceForKey(createKey(key)))
		return widget.preferenceForKey(createKey(key));
		else
		return null;
		}
	}

// delete tmp files
function delTmpFiles (file) {

        if(!file){
		sys1=widget.system("/bin/rm -rf .noteit.tmp", null).status;
		sys2=widget.system("/bin/rm -f /tmp/noteit.*", null).status;}
		else
		{sys1=widget.system("/bin/rm -f "+file, null).status;}

}

// main for text
function doTextTasks(e)
{

	setNbChars();	//showAlert(_widget.text.nbchars);
	//showAlert(e.charCode,true);
	makeTmpfile(e);
	loadTextMeasure(e);

}


function setNbChars(n) {
	if(typeof (n) == "number")
	_widget.text.nbchars = n;
	else
	_widget.text.nbchars = getNbChars();
	}

function getNbChars()
{
	return document.getElementById("inputText").value.length+1;
	}

//debug
function assert(fact) {
     if (!fact) {
          showAlert("Assert failure!");
     }
}


