  def toQUOTED(txt)

  # none converted sign A1-BF
  #when /\x81/ then txt=txt.gsub(/U\xCC\x81+/, "=EA") end

  #carriage return and new line
  if /[\n\r]/.match(txt) then txt=txt.gsub(/[\n\r]+/, "=0A") end

  #right single quotation mark
  if /\xE2\x80\x99/.match(txt) then txt=txt.gsub(/\xE2\x80\x99/, "=27") end

  #horizontal ellipsis
  if /\xE2\x80\xA6/.match(txt) then txt=txt.gsub(/\xE2\x80\xA6/, "=2E=2E=2E") end

  #various signs
  if /\xC2[\xA0-\xBF]/.match(txt) then
     txt=txt.gsub(/(\xC2)([\xA0-\xBF])+/, '\2')  end

  #euro sign
  if /\xE2\x82\xAC/.match(txt) then txt=txt.gsub(/\xE2\x82\xAC+/, "\xA4") end

  #A
  if /A\xCC\x80/.match(txt) then txt=txt.gsub(/A\xCC\x80+/, "=C0") end
  if /A\xCC\x81/.match(txt) then txt=txt.gsub(/A\xCC\x81+/, "=C1") end
  if /A\xCC\x82/.match(txt) then txt=txt.gsub(/A\xCC\x82+/, "=C2") end
  if /A\xCC\x82/.match(txt) then txt=txt.gsub(/A\xCC\x83+/, "=C3") end
  if /A\xCC\x83/.match(txt) then txt=txt.gsub(/A\xCC\x88+/, "=C4") end
  if /A\xCC\x8A/.match(txt) then txt=txt.gsub(/A\xCC\x8A+/, "=C5") end
  if /\xC3\x86/.match(txt) then txt=txt.gsub(/A\xCC\x81+/, "=C6") end

  #CEDILLA
  if /C\xCC\xA7/.match(txt) then txt=txt.gsub(/C\xCC\xA7+/, "=C7") end

  #E
  if /E\xCC\x80/.match(txt) then txt=txt.gsub(/E\xCC\x80+/, "=C8") end
  if /E\xCC\x81/.match(txt) then txt=txt.gsub(/E\xCC\x81+/, "=C9") end
  if /E\xCC\x82/.match(txt) then txt=txt.gsub(/E\xCC\x82+/, "=CA") end
  if /E\xCC\x88/.match(txt) then txt=txt.gsub(/E\xCC\x88+/, "=CB") end

  #I
  if /I\xCC\x80/.match(txt) then txt=txt.gsub(/I\xCC\x80+/, "=CC") end
  if /I\xCC\x81/.match(txt) then txt=txt.gsub(/I\xCC\x81+/, "=CD") end
  if /I\xCC\x82/.match(txt) then txt=txt.gsub(/I\xCC\x82+/, "=CE") end
  if /I\xCC\x88/.match(txt) then txt=txt.gsub(/I\xCC\x88+/, "=CF") end

  #D icelandic
  if /\xC3\x90/.match(txt) then txt=txt.gsub(/\xC3\x90+/, "=D0") end

  #N tilde
  if /N\xCC\x83/.match(txt) then txt=txt.gsub(/N\xCC\x83+/, "=D1") end

  #O
  if /O\xCC\x80/.match(txt) then txt=txt.gsub(/O\xCC\x80+/, "=D2") end
  if /O\xCC\x81/.match(txt) then txt=txt.gsub(/O\xCC\x81+/, "=D3") end
  if /O\xCC\x82/.match(txt) then txt=txt.gsub(/O\xCC\x82+/, "=D4") end
  if /O\xCC\x83/.match(txt) then txt=txt.gsub(/O\xCC\x83+/, "=D5") end
  if /O\xCC\x88/.match(txt) then txt=txt.gsub(/O\xCC\x88+/, "=D6") end
  if /\xC5\x92/.match(txt) then txt=txt.gsub(/O\xCC\x88+/, "=4F=45") end

  #Multiply sign
  if /\xC3\x97/.match(txt) then txt=txt.gsub(/\xC3\x97+/, "=D7") end

  #O slash
  if /\xC3\x98/.match(txt) then txt=txt.gsub(/\xC3\x98+/, "=D8") end

  #U
  if /U\xCC\x80/.match(txt) then txt=txt.gsub(/U\xCC\x80+/, "=D9") end
  if /U\xCC\x81/.match(txt) then txt=txt.gsub(/U\xCC\x81+/, "=DA") end
  if /U\xCC\x82/.match(txt) then txt=txt.gsub(/U\xCC\x82+/, "=DB") end
  if /U\xCC\x88/.match(txt) then txt=txt.gsub(/U\xCC\x88+/, "=DC") end

  #Y
  if /Y\xCC\x81/.match(txt) then txt=txt.gsub(/Y\xCC\x81+/, "=DD") end

  #P htorn icelandic
  if /\xC3\x9E/.match(txt) then txt=txt.gsub(/\xC3\x9E+/, "=DE") end

  #Small sharp (german sz ligature)
  if /\xC3\x9F/.match(txt) then txt=txt.gsub(/\xC3\x9F+/, "=DF") end

  #a
  if /a\xCC\x80/.match(txt) then txt=txt.gsub(/a\xCC\x80+/, "=E0") end
  if /a\xCC\x81/.match(txt) then txt=txt.gsub(/a\xCC\x81+/, "=E1") end
  if /a\xCC\x82/.match(txt) then txt=txt.gsub(/a\xCC\x82+/, "=E2") end
  if /a\xCC\x83/.match(txt) then txt=txt.gsub(/a\xCC\x83+/, "=E3") end
  if /a\xCC\x88/.match(txt) then txt=txt.gsub(/a\xCC\x88+/, "=E4") end
  if /a\xCC\x8A/.match(txt) then txt=txt.gsub(/a\xCC\x8A+/, "=E5") end
  if /\xC3\xA6/.match(txt) then txt=txt.gsub(/\xC3\xA6+/, "=E6") end

  #c cedilla
  if /c\xCC\xA7/.match(txt) then txt=txt.gsub(/c\xCC\xA7+/, "=E7") end

  #e
  if /e\xCC\x80/.match(txt) then txt=txt.gsub(/e\xCC\x80+/, "=E8") end
  if /e\xCC\x81/.match(txt) then txt=txt.gsub(/e\xCC\x81+/, "=E9") end
  if /e\xCC\x82/.match(txt) then txt=txt.gsub(/e\xCC\x82+/, "=EA") end
  if /e\xCC\x88/.match(txt) then txt=txt.gsub(/e\xCC\x88+/, "=EB") end

  #i
  if /i\xCC\x80/.match(txt) then txt=txt.gsub(/i\xCC\x80+/, "=EC") end
  if /i\xCC\x81/.match(txt) then txt=txt.gsub(/i\xCC\x81+/, "=ED") end
  if /i\xCC\x82/.match(txt) then txt=txt.gsub(/i\xCC\x82+/, "=EE") end
  if /i\xCC\x88/.match(txt) then txt=txt.gsub(/i\xCC\x88+/, "=EF") end

  #d small eth icelandic
  if /\xC3\x80/.match(txt) then txt=txt.gsub(/\xC3\x80+/, "=F0") end

  #n tilde
  if /n\xCC\x83/.match(txt) then txt=txt.gsub(/n\xCC\x83+/, "=F1") end

  #o
  if /o\xCC\x80/.match(txt) then txt=txt.gsub(/o\xCC\x80+/, "=F2") end
  if /o\xCC\x81/.match(txt) then txt=txt.gsub(/o\xCC\x81+/, "=F3") end
  if /o\xCC\x82/.match(txt) then txt=txt.gsub(/o\xCC\x82+/, "=F4") end
  if /o\xCC\x83/.match(txt) then txt=txt.gsub(/o\xCC\x83+/, "=F5") end
  if /o\xCC\x88/.match(txt) then txt=txt.gsub(/o\xCC\x88+/, "=F6") end
  if /\xC5\x93/.match(txt) then txt=txt.gsub(/O\xCC\x88+/, "=6F=65") end

  #division sign
  if /\xC3\xB7/.match(txt) then txt=txt.gsub(/\xC3\xB7+/, "=F7") end

  #small o slash
  if /\xC3\xB8/.match(txt) then txt=txt.gsub(/\xC3\xB8+/, "=F8") end

  #u
  if /u\xCC\x80/.match(txt) then txt=txt.gsub(/u\xCC\x80+/, "=F9") end
  if /u\xCC\x81/.match(txt) then txt=txt.gsub(/u\xCC\x81+/, "=FA") end
  if /u\xCC\x82/.match(txt) then txt=txt.gsub(/u\xCC\x82+/, "=FB") end
  if /u\xCC\x88/.match(txt) then txt=txt.gsub(/u\xCC\x88+/, "=FC") end

  #small y acute accent
  if /y\xCC\x81/.match(txt) then txt=txt.gsub(/Y\xCC\x81+/, "=FD") end

  #p small thorn icelandic
  if /\xC3\xBE/.match(txt) then txt=txt.gsub(/\xC3\xBE+/, "=FE") end

  #y dieresis or umlaut mark
  if /\xC3\xBF/.match(txt) then txt=txt.gsub(/\xC3\xBF+/, "=FF")
  else return txt
  end
 end


  def toLATIN1(txt)

  # none converted sign A1-BF
  #when /\x81/ then txt=txt.gsub(/U\xCC\x81+/, "\xEA") end

  #remove this if not use with noteit
  if /\=27/.match(txt) then txt=txt.gsub(/\=27+/, "\x27") end

  #right single quotation mark
  if /\xE2\x80\x99/.match(txt) then txt=txt.gsub(/\xE2\x80\x99/, "\x27") end

  #horizontal ellipsis
  if /\xE2\x80\xA6/.match(txt) then txt=txt.gsub(/\xE2\x80\xA6/, "\x2E\x2E\x2E") end

  #various signs
  if /\xC2[\xA0-\xBF]/.match(txt) then txt=txt.gsub(/(\xC2)([\xA0-\xBF])+/, '\2') end

  #euro sign
  if /\xE2\x82\xAC/.match(txt) then txt=txt.gsub(/\xE2\x82\xAC+/, "\x20\xAC") end

  #A
  if /A\xCC\x80/.match(txt) then txt=txt.gsub(/A\xCC\x80+/, "\xC0") end
  if /A\xCC\x81/.match(txt) then txt=txt.gsub(/A\xCC\x81+/, "\xC1") end
  if /A\xCC\x82/.match(txt) then txt=txt.gsub(/A\xCC\x82+/, "\xC2") end
  if /A\xCC\x82/.match(txt) then txt=txt.gsub(/A\xCC\x83+/, "\xC3") end
  if /A\xCC\x83/.match(txt) then txt=txt.gsub(/A\xCC\x88+/, "\xC4") end
  if /A\xCC\x8A/.match(txt) then txt=txt.gsub(/A\xCC\x8A+/, "\xC5") end
  if /\xC3\x86/.match(txt) then txt=txt.gsub(/A\xCC\x81+/, "\xC6") end

  #CEDILLA
  if /C\xCC\xA7/.match(txt) then txt=txt.gsub(/C\xCC\xA7+/, "\xC7") end

  #E
  if /E\xCC\x80/.match(txt) then txt=txt.gsub(/E\xCC\x80+/, "\xC8") end
  if /E\xCC\x81/.match(txt) then txt=txt.gsub(/E\xCC\x81+/, "\xC9") end
  if /E\xCC\x82/.match(txt) then txt=txt.gsub(/E\xCC\x82+/, "\xCA") end
  if /E\xCC\x88/.match(txt) then txt=txt.gsub(/E\xCC\x88+/, "\xCB") end

  #I
  if /I\xCC\x80/.match(txt) then txt=txt.gsub(/I\xCC\x80+/, "\xCC") end
  if /I\xCC\x81/.match(txt) then txt=txt.gsub(/I\xCC\x81+/, "\xCD") end
  if /I\xCC\x82/.match(txt) then txt=txt.gsub(/I\xCC\x82+/, "\xCE") end
  if /I\xCC\x88/.match(txt) then txt=txt.gsub(/I\xCC\x88+/, "\XCF") end

  #D icelandic
  if /\xC3\x90/.match(txt) then txt=txt.gsub(/\xC3\x90+/, "\xD0") end

  #N tilde
  if /N\xCC\x83/.match(txt) then txt=txt.gsub(/N\xCC\x83+/, "\xD1") end

  #O
  if /O\xCC\x80/.match(txt) then txt=txt.gsub(/O\xCC\x80+/, "\xD2") end
  if /O\xCC\x81/.match(txt) then txt=txt.gsub(/O\xCC\x81+/, "\xD3") end
  if /O\xCC\x82/.match(txt) then txt=txt.gsub(/O\xCC\x82+/, "\xD4") end
  if /O\xCC\x83/.match(txt) then txt=txt.gsub(/O\xCC\x83+/, "\xD5") end
  if /O\xCC\x88/.match(txt) then txt=txt.gsub(/O\xCC\x88+/, "\xD6") end
  if /\xC5\x92/.match(txt) then txt=txt.gsub(/O\xCC\x88+/, "=4F=45") end

  #Multiply sign
  if /\xC3\x97/.match(txt) then txt=txt.gsub(/\xC3\x97+/, "\xD7") end

  #O slash
  if /\xC3\x98/.match(txt) then txt=txt.gsub(/\xC3\x98+/, "\xD8") end

  #U
  if /U\xCC\x80/.match(txt) then txt=txt.gsub(/U\xCC\x80+/, "\xD9") end
  if /U\xCC\x81/.match(txt) then txt=txt.gsub(/U\xCC\x81+/, "\xDA") end
  if /U\xCC\x82/.match(txt) then txt=txt.gsub(/U\xCC\x82+/, "\xDB") end
  if /U\xCC\x88/.match(txt) then txt=txt.gsub(/U\xCC\x88+/, "\xDC") end

  #Y
  if /Y\xCC\x81/.match(txt) then txt=txt.gsub(/Y\xCC\x81+/, "\xDD") end

  #P htorn icelandic
  if /\xC3\x9E/.match(txt) then txt=txt.gsub(/\xC3\x9E+/, "\xDE") end

  #Small sharp (german sz ligature)
  if /\xC3\x9F/.match(txt) then txt=txt.gsub(/\xC3\x9F+/, "\xDF") end

  #a
  if /a\xCC\x80/.match(txt) then txt=txt.gsub(/a\xCC\x80+/, "\xE0") end
  if /a\xCC\x81/.match(txt) then txt=txt.gsub(/a\xCC\x81+/, "\xE1") end
  if /a\xCC\x82/.match(txt) then txt=txt.gsub(/a\xCC\x82+/, "\xE2") end
  if /a\xCC\x83/.match(txt) then txt=txt.gsub(/a\xCC\x83+/, "\xE3") end
  if /a\xCC\x88/.match(txt) then txt=txt.gsub(/a\xCC\x88+/, "\xE4") end
  if /a\xCC\x8A/.match(txt) then txt=txt.gsub(/a\xCC\x8A+/, "\xE5") end
  if /\xC3\xA6/.match(txt) then txt=txt.gsub(/\xC3\xA6+/, "\xE6") end

  #c cedilla
  if /c\xCC\xA7/.match(txt) then txt=txt.gsub(/c\xCC\xA7+/, "\xE7") end

  #e
  if /e\xCC\x80/.match(txt) then txt=txt.gsub(/e\xCC\x80+/, "\xE8") end
  if /e\xCC\x81/.match(txt) then txt=txt.gsub(/e\xCC\x81+/, "\xE9") end
  if /e\xCC\x82/.match(txt) then txt=txt.gsub(/e\xCC\x82+/, "\xEA") end
  if /e\xCC\x88/.match(txt) then txt=txt.gsub(/e\xCC\x88+/, "\xEB") end


  #i
  if /i\xCC\x80/.match(txt) then txt=txt.gsub(/i\xCC\x80+/, "\xEC") end
  if /i\xCC\x81/.match(txt) then txt=txt.gsub(/i\xCC\x81+/, "\xED") end
  if /i\xCC\x82/.match(txt) then txt=txt.gsub(/i\xCC\x82+/, "\xEE") end
  if /i\xCC\x88/.match(txt) then txt=txt.gsub(/i\xCC\x88+/, "\xEF") end

  #d small eth icelandic
  if /\xC3\x80/.match(txt) then txt=txt.gsub(/\xC3\x80+/, "\xF0") end

  #n tilde
  if /n\xCC\x83/.match(txt) then txt=txt.gsub(/n\xCC\x83+/, "\xF1") end

  #o
  if /o\xCC\x80/.match(txt) then txt=txt.gsub(/o\xCC\x80+/, "\xF2") end
  if /o\xCC\x81/.match(txt) then txt=txt.gsub(/o\xCC\x81+/, "\xF3") end
  if /o\xCC\x82/.match(txt) then txt=txt.gsub(/o\xCC\x82+/, "\xF4") end
  if /o\xCC\x83/.match(txt) then txt=txt.gsub(/o\xCC\x83+/, "\xF5") end
  if /o\xCC\x88/.match(txt) then txt=txt.gsub(/o\xCC\x88+/, "\xF6") end
  if /\xC5\x93/.match(txt) then txt=txt.gsub(/O\xCC\x88+/, "=6F=65") end

  #division sign
  if /\xC3\xB7/.match(txt) then txt=txt.gsub(/\xC3\xB7+/, "\xF7") end

  #small o slash
  if /\xC3\xB8/.match(txt) then txt=txt.gsub(/\xC3\xB8+/, "\xF8") end

  #u
  if /u\xCC\x80/.match(txt) then txt=txt.gsub(/u\xCC\x80+/, "\xF9") end
  if /u\xCC\x81/.match(txt) then txt=txt.gsub(/u\xCC\x81+/, "\xFA") end
  if /u\xCC\x82/.match(txt) then txt=txt.gsub(/u\xCC\x82+/, "\xFB") end
  if /u\xCC\x88/.match(txt) then txt=txt.gsub(/u\xCC\x88+/, "\xFC") end

  #small y acute accent
  if /y\xCC\x81/.match(txt) then txt=txt.gsub(/Y\xCC\x81+/, "\xFD") end

  #p small thorn icelandic
  if /\xC3\xBE/.match(txt) then txt=txt.gsub(/\xC3\xBE+/, "\xFE") end

  #y dieresis or umlaut mark
  if /\xC3\xBF/.match(txt) then txt=txt.gsub(/\xC3\xBF+/, "\xFF")
  else return txt
  end
 end


  def utf8toLatin1(txt, enctype)
  l1 = "LATIN1"
  qt = "QUOTED"

  if !(enctype == l1 || enctype == qt)
  return "error: incorrect enctype, choose LATIN1 or QUOTED"
  end

  case enctype
  when l1 then toLATIN1(txt)
  when qt then toQUOTED(txt)
  else "Error"
  end
end